using System;
using System.Collections.Generic;
using System.Linq;
using System.Diagnostics;

namespace LINQ4
{

    class Order
    {
        public int order_id;
        public int customer_id;
        public string description;
    }

    class Customer
    {
        public int id;
        public string name;
        public int totalpurchase;
        public Address addres;
    }

    class Address
    {
        public string city;
        public int number;
    }

    class Shop
    {
        public Customer[] customers;
        public Order[] orders;

    }
    class Program
    {
        static void Main(string[] args)
        {
            Customer[] customers = new Customer[]
                                    {
                                        new Customer() { id = 1, totalpurchase =200,name="Janek", addres = new Address() { city="Bielsko", number=11 } },
                                        new Customer() { id = 2, totalpurchase =400, name = "Jasiu", addres = new Address() { city="Bielsko", number=12 } },
                                        new Customer() { id = 3, totalpurchase =500, name = "Piotr", addres = new Address() { city="Bielsko", number=13 } },
                                        new Customer() { id = 4, totalpurchase =400, name = "Kazimierz" , addres = new Address() { city="Bielsko", number=14 }},
                                        new Customer() { id = 5, totalpurchase =600, name = "Jasiu", addres = new Address() { city="Bielsko", number=15 } },
                                    };

            Order[] orders = new Order[]
                                   {
                                        new Order { order_id = 1, customer_id = 1, description = "Koło" },
                                        new Order { order_id = 2, customer_id = 1, description = "Pompka" },
                                        new Order { order_id = 3, customer_id = 2, description = "Rower" },
                                        new Order { order_id = 4, customer_id = 3, description = "Wiadro" },
                                        new Order { order_id = 5, customer_id = 4, description = "Koło" },
                                    };

            var Q1 = from c in customers
                     join o in orders on c.id equals o.customer_id
                     select new { c.id, c.name, c.totalpurchase, o.order_id, o.description };

            foreach (var q in Q1)
                Console.WriteLine(q.id + " " + q.name + " " + q.totalpurchase + " " + q.order_id + " " + q.description);

            Console.WriteLine();

            var Q2 = customers.Join(orders, c => c.id, o => o.customer_id, (c, o) =>
             new { c.id, c.name, c.totalpurchase, o.order_id, o.description });

            foreach (var q in Q1)
                Console.WriteLine(q.id + " " + q.name + " " + q.totalpurchase + " " + q.order_id + " " + q.description);

            Console.WriteLine(); Console.WriteLine();

            Shop shop = new Shop() { customers = customers, orders = orders };

            var Q3 = from c in shop.customers
                     join o in shop.orders on c.id equals o.customer_id
                     select new { c.id, c.name, c.totalpurchase, o.order_id, o.description };

            foreach (var q in Q3)
                Console.WriteLine(q.id + " " + q.name + " " + q.totalpurchase + " " + q.order_id + " " + q.description);

            Console.WriteLine();

            var Q4 = shop.customers.Join(shop.orders, c => c.id, o => o.customer_id, (c, o) =>
             new { c.id, c.name, c.addres.number, c.totalpurchase, o.order_id, o.description });

            foreach (var q in Q4)
                Console.WriteLine(q.id + " " + q.name + " " + q.number + " " + q.totalpurchase + " " + q.order_id + " " + q.description);






            var zawodnicy = new List<Zawodnik>
                           {
                              new Zawodnik { Name = "Jan", Druzyna = "A1", Punkty = 110 },
                              new Zawodnik { Name = "Piotr", Druzyna = "A1", Punkty = 20 },
                              new Zawodnik { Name = "Marek", Druzyna = "B2", Punkty = 60 },
                              new Zawodnik { Name = "Andrzej", Druzyna = "B2", Punkty = 40 },
                               new Zawodnik { Name = "Marek", Druzyna = "C3", Punkty = 60 },
                              new Zawodnik { Name = "Wojtek", Druzyna = "C3", Punkty = 55 }
                          };

            var sumaPunktow = from p in zawodnicy
                              group p by p.Druzyna into druzyna orderby druzyna.Sum(x => x.Punkty) 
                                  select new { TeamX = druzyna.Key, SumaPkt = druzyna.Sum(x => x.Punkty) };

            foreach (var item in sumaPunktow)
            {
                Console.WriteLine(item.TeamX + "  " + item.SumaPkt);
            }
            Console.WriteLine();

            var sumaPunktow2 = zawodnicy.GroupBy(p => p.Druzyna).Select(p => new { TeamX = p.Key, SumaPkt = p.Sum(x => x.Punkty) }).OrderBy(p => p.SumaPkt);

            foreach (var item in sumaPunktow2)
            {
                Console.WriteLine(item.TeamX + "  " + item.SumaPkt);
            }
            Console.WriteLine();


            int d = 3_000_000;
            int[] X = new int[d];
            for (int i = 0; i < d; i++)
            {
                X[i] = i % 5;
            }

            Stopwatch s1 = new Stopwatch();
            s1.Start();
            double av1 = X.Average(x => x * x);
            s1.Stop();
            Console.WriteLine("LINQ " + av1 + "   " + s1.Elapsed);


            Stopwatch s2 = new Stopwatch();
            s2.Start();
            double av2 = 0;
            for (int i = 0; i < d; i++)
            {
                av2 += X[i] * X[i];
            }
            av2 /= d;
            s2.Stop();
            Console.WriteLine("For " + av2 + "   " + s2.Elapsed);


            Stopwatch s3 = new Stopwatch();
            s3.Start();
            double av3 = 0;
            int d3 = d - 1;
            for (int i = 0; i < d3; i += 3)
            {
                av3 += X[i] * X[i];
                av3 += X[i + 1] * X[i + 1];
                av3 += X[i + 2] * X[i + 2];
            }
            av3 /= d;
            s3.Stop();
            Console.WriteLine("For3 " + av3 + "   " + s3.Elapsed);


            int w1 = 1, w2 = 1;

            List<Zupa> listZupa = new List<Zupa>();
            List<Drugie> listDrugie = new List<Drugie>();
            List<Obiad> listObiad = new List<Obiad>();

            Random R = new Random();

            for (int i = 0; i < 40; i++)
            {

                Zupa zupa;
                Drugie drugie;

                w1 = R.Next(0, 3); w2 = R.Next(0, 2);

                zupa = ObiadFactory.NowaZupa(w1, i);
                zupa.Cena = R.Next(2, 10);
                zupa.ObiadId = i;

                drugie = ObiadFactory.NoweDrugie(w2, i);
                drugie.Cena = R.Next(2, 10);
                drugie.ObiadId = i;

                Obiad obiad = new Obiad(zupa, drugie);

                //  Obiad obiad2 = new Obiad(w1, w2, i);
                obiad.Wydaj();

                listZupa.Add(zupa);
                listDrugie.Add(drugie);


            }


            //  Ceny i nazwa drugiego dania zestawow obiadowych, gdzie zupa.Nazwa == "pomidorowa"
            //  Średnia cen poszczegolnych gatunkow zup 

            Console.ReadLine();



            Console.ReadKey();

        }
    }

    class Zawodnik
    {
        public string Name, Druzyna;
        public int Punkty;
    }


    class A
    {
        public int x;
    }
    class B : A { }

    class C : A { }
}



  
      


    class ObiadFactory
    {
        public static Zupa NowaZupa(int w, int i)
        {
            if (w == 1)
                return new Pomidorawa() { Nazwa = "pomidorowa" + i.ToString() };
            else if (w == 2)
                return new Ogorkowa() { Nazwa = "ogorkowa" + i.ToString() };
            else
                return new Grochowa() { Nazwa = "grochowa" + i.ToString() };
        }

        public static Drugie NoweDrugie(int w, int i)
        {
            if (w == 1)
                return new Ryba() { Nazwa = "ryba" + i.ToString() };
            else
                return new Pierogi() { Nazwa = "pierogi" + i.ToString() };
        }
    }




    class Obiad
    {
        public int Id;
        public double Cena;
        public Zupa TwojaZupa;
        public Drugie TwojeDrugie;
        //  public Napoj TwojNapoj;

        public Obiad(Zupa TwojaZupa, Drugie TwojeDrugie) // Dependency Injection
        {
            this.TwojaZupa = TwojaZupa;
            this.TwojeDrugie = TwojeDrugie;
            //  this.TwojNapoj = TwojNapoj;


        }

        //public Obiad(int w1, int w2, int i) 
        //{

        //    if (w2 == 1)
        //        TwojaZupa = new Pomidorawa() { Nazwa = "pomidorowa" + i.ToString() };
        //    else
        //        TwojaZupa = new Ogorkowa() { Nazwa = "ogorkowa" + i.ToString() };


        //    if (w2 == 1)
        //        TwojeDrugie = new Ryba() { Nazwa = "ryba" + i.ToString() };
        //    else
        //        TwojeDrugie = new Pierogi() { Nazwa = "pierogi" + i.ToString() };
        //}




        public void Wydaj()
        {
            TwojaZupa.Wydaj();
            TwojeDrugie.Wydaj();
            // TwojNapoj.Wydaj();
            Cena = 0.9 * (TwojaZupa.Cena + TwojeDrugie.Cena); // TwojNapoj.Cena);
        }


    }

    abstract class Zupa
    {
        public int ObiadId;
        public double Cena = 10;
        public string Nazwa;
        public abstract void Wydaj();
    }

    class Pomidorawa : Zupa
    {

        public override void Wydaj()
        {
            Console.WriteLine("pom");
        }
    }

    class Ogorkowa : Zupa
    {

        public override void Wydaj()
        {
            Console.WriteLine("og");
        }
    }

    class Grochowa : Zupa
    {

        public override void Wydaj()
        {
            Console.WriteLine("gr");
        }
    }


    abstract class Drugie
    {
        public int ObiadId;
        public double Cena = 20;
        public string Nazwa;
        public abstract void Wydaj();
    }

    class Ryba : Drugie
    {
        public override void Wydaj()
        {
            Console.WriteLine("ryba");
        }
    }

    class Pierogi : Drugie
    {
        public override void Wydaj()
        {
            Console.WriteLine("pier");
        }
    }

    abstract class Napoj
    {
        public int ObiadId;
        public double Cena = 5;
        public string Nazwa;
        public abstract void Wydaj();
    }

    class Herbata : Napoj
    {
        public override void Wydaj()
        {
            Console.WriteLine("herbata");
        }
    }

    class Woda : Napoj
    {
        public override void Wydaj()
        {
            Console.WriteLine("woda");
        }
    }

